#include <stdio.h>
#include <string.h>
#include <conio.h>


int main(int argc, char ** argv)
{
   int  allowed_char[256], i, max, c;
   char * str;


   for (i=0; i < 256; i++)
      allowed_char[i] = 0;

   if (argc == 1)
   {
      // error
      return 255;
   }
   else
   {
      if (argc >= 2)
      {
         // get allowed characters for user input
         str = argv[1];
         max = strlen(str);
         for (i=0; i < max; i++)
         {
            c = str[i];
            if ((c >= 32) && (c <= 254))
               allowed_char[c] = 1;
         }
      }

      // display optional string on stdout and stderr
      if (argc >= 3)
      {
         str = argv[2];
         fprintf(stdout, "%s", str);
         //fprintf(stderr, "%s", str);
         fflush(stdout);
         //fflush(stderr);
      }

      // get user input
      do
      {
         c = _getch();
         if (allowed_char[c] == 1)
         {
            fprintf(stdout, "<%c>\n", c);
            // fprintf(stderr, "%c\n", c);
            fflush(stdout);
            // fflush(stderr);
            return c;
         }
      } while (1);
   }
}
